GDAL-RASTER-POLYGONIZE(1)

NAME
gdal-raster-polygonize - Create a polygon feature dataset from a raster band

Added in version 3.11.

SYNOPSIS

            Usage: gdal raster polygonize [OPTIONS] <INPUT> <OUTPUT>

            Create a polygon feature dataset from a raster band.

            Positional arguments:
              -i, --input <INPUT>                                  Input raster datasets [required]
              -o, --output <OUTPUT>                                Output vector dataset [required]

            Common Options:
              -h, --help                                           Display help message and exit
              --json-usage                                         Display usage as JSON document and exit
              --config <KEY>=<VALUE>                               Configuration option [may be repeated]
              -q, --quiet                                          Quiet mode (no progress bar)

            Options:
              -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed)
              --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated]
              --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated]
              --overwrite                                          Whether overwriting existing output is allowed
              --update                                             Whether to open existing dataset in update mode
              --overwrite-layer                                    Whether overwriting existing output is allowed
              --append                                             Whether appending to existing layer is allowed
              --output-layer <OUTPUT-LAYER>                        Output layer name
              -b, --band <BAND>                                    Input band (1-based index) (default: 1)
              --attribute-name <ATTRIBUTE-NAME>                    Name of the field with the pixel value (default: DN)
              -c, --connect-diagonal-pixels                        Consider diagonal pixels as connected

            Advanced Options:
              --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated]
              --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated]
              --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated]

DESCRIPTION

gdal raster polygonize creates vector polygons for all connected regions of pixels in the raster sharing a common pixel value. Each polygon is created with an attribute indicating the pixel value of that polygon. Pixels that are set to the NoData value, or masked using an external mask band, are not included in processing.

The utility can create the output vector dataset if it does not already exist, otherwise it may append to an existing one.

The utility is based on the :GDALPolygonize() function which has additional details on the algorithm.

Since GDAL 3.12, this algorithm can be part of a gdal pipeline.

  Standard options

    -f, --of, --format, --output-format <OUTPUT-FORMAT>
        Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

    --co, --creation-option <NAME>=<VALUE>
        Many formats have one or more optional creation options that can be used to control particulars about the file created. For instance, the GeoTIFF driver supports creation options to control compression, and whether the file should be tiled.

        May be repeated.

        The creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Raster drivers format specific documentation for legal creation options for each format.

    -lco <NAME>=<VALUE>
        Layer creation option (format specific)

    --overwrite
        Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

    --update
        Whether the output dataset must be opened in update mode. Implies that it already exists.

    --overwrite-layer
        Whether overwriting the existing output vector layer is allowed.

    --append
        Whether appending features to the existing output vector layer is allowed

    -b, --band <BAND>
        Picks a particular band to polygonize. Defaults to band 1.

    --nln, --output-layer <OUTPUT-LAYER>
        Provides a name for the output vector layer. Defaults to "polygonize".

    --attribute-name <ELEVATION-NAME>
        The name of the field to create (defaults to "DN").

    -c, --connect-diagonal-pixels
        Consider diagonal pixels (pixels at the corners) as connected. The default behavior is to only consider pixels that are touching the edges as connected, which is the same as 4-connectivity. When this option is selected, the algorithm will also consider pixels at the corners as connected, which is the same as 8-connectivity.

  Advanced options

    --oo, --open-option <NAME>=<VALUE>
        Dataset open option (format specific).

        May be repeated.

    --if, --input-format <format>
        Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

        May be repeated.

Added in version 3.12.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a vector dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

NOTE:
        However this algorithm is not natively streaming compatible. Consequently a in-memory temporary dataset will be generated, which may cause significant processing time at opening.

EXAMPLES

  Example 1: Create a shapefile with polygons for the connected regions of band 1 of the input GeoTIFF.

                    gdal raster polygonize input.tif polygonize.shp

AUTHOR
Even Rouault <even.rouault@spatialys.com>

COPYRIGHT
1998-2026